/* : hiddata.h
 * : Christian Starkjohann
 * : microsin.ru
 *  : 2008-04-11
 * : 4
 * Copyright: (c) 2008 by OBJECTIVE DEVELOPMENT Software GmbH
 * : GNU GPL v2 (. License.txt)   (CommercialLicense.txt) 
 * : $Id: hiddata.h 553 2008-04-17 19:00:20Z cs $
 */

#ifndef __HIDDATA_H_INCLUDED__
#define __HIDDATA_H_INCLUDED__

/*
 :
          HID feature. 
  ,   Windows  (  
)  libusb  Unix.      : 
"-lhid -lusb -lsetupapi"  Windows  `libusb-config --libs`  Unix.
*/

/* ------------------------------------------------------------------------ */

#define USBOPEN_SUCCESS         0   /*   */
#define USBOPEN_ERR_ACCESS      1   /*       */
#define USBOPEN_ERR_IO          2   /*  I/O */
#define USBOPEN_ERR_NOTFOUND    3   /*    */

/* ------------------------------------------------------------------------ */

typedef struct usbDevice    usbDevice_t;
/*  (opaque)  ,   USB.     Windows
 *   libusb ,     backend.
 */

/* ------------------------------------------------------------------------ */

int usbhidOpenDevice(usbDevice_t **device, int vendorID, char *vendorName, int productID, char *productName, int usesReportIDs);
/*     USB. 'vendorID'  'productID'  
 *  Vendor-ID  Product-ID ,   .  'vendorName' 
 *  'productName'   ( NULL),     ,   
 *       .    
 *  -ID,  'usesReportIDs'    .
 * :    ,  USBOPEN_SUCCESS  
 *  '*device'    (opaque) ,  .
 *       usbhidCloseDevice().    ,
 *     ,   .
 */
void    usbhidCloseDevice(usbDevice_t *device);
/*  ,   usbhidOpenDevice(),     .
 */
int usbhidSetReport(usbDevice_t *device, char *buffer, int len);
/*    feature   .  ID  
 *        'len'     
 *   ID.     -ID, buffer[0] 
 *    0 (dummy  ID).
 * : 0    ,   .
 */
int usbhidGetReport(usbDevice_t *device, int reportID, char *buffer, int *len);
/*    feature   .  -ID 
 *    'reportID'.       
 *    'buffer'   ,   
 *  'len'    .    
 *  (  -ID )    'buffer'  
 *       '*len'.
 * : 0    ,   .
 */

/* ------------------------------------------------------------------------ */

#endif /* __HIDDATA_H_INCLUDED__ */
